
import java.io.*;
import java.lang.*;
import java.util.*;
import java.math.*;
import monitor.*;


/**
 * @author Cesare Stefanelli e Antonio Corradi
 *
 */
public class Suez{

  public static void main(String[] args) {
	
	int NumPasseggeri, NumPetroliere, NumMerci, NumNaviTot, i;
 	Monitor monitorOgg = new Monitor();

	try {
		NumPasseggeri = Integer.parseInt(args[0]);
		NumPetroliere = Integer.parseInt(args[1]);
		NumMerci = Integer.parseInt(args[2]);
		NumNaviTot = NumPasseggeri+NumPetroliere+ NumMerci;
	}
	catch (Exception e) {
		System.err.println("uso: Suez  NumPasseggeri NumPetroliere  NumMerci");
		NumPasseggeri = 2;
		NumPetroliere = 2;
		NumMerci = 2;
		NumNaviTot = 6;
	}

      Nave NaveVett [] = new Nave [NumNaviTot];

	for(i=0;i<NumPasseggeri;i++)
		NaveVett[i] = new Nave(monitorOgg, 0);
	for(i=NumPasseggeri;i<NumPasseggeri+NumPetroliere;i++)
		NaveVett[i] = new Nave(monitorOgg, 1);
	for(i=NumPasseggeri+NumPetroliere;i<NumNaviTot;i++)
		NaveVett[i] = new Nave(monitorOgg, 2);
	
	System.err.println("NumPasseggeri NumPetroliere NumMerci" + NumPasseggeri +NumPetroliere +NumMerci);
	}
}


class Nave implements Runnable {
    	static boolean flag = true;

 	Monitor monitorOgg;
	Thread NaveThread;
	int TipoNave;

	Nave (Monitor Monitor, int tipo) {
		monitorOgg = Monitor;
		TipoNave = tipo;
		NaveThread  = new Thread (this);
		NaveThread.start();
	}
		
    	public void run() {

	  Random AttesaRandom = new Random();
//	  System.out.println((new Double(AttesaRandom.nextDouble()*1000).intValue()));


        while(true)  {

		try {
			Thread.sleep((new Double(AttesaRandom.nextDouble()*1000).intValue())); 
		} catch(InterruptedException e){}

		monitorOgg.richiestaAccesso(TipoNave);
		try {
			Thread.sleep((new Double(AttesaRandom.nextDouble()*1000).intValue())); 
		} catch(InterruptedException e){}
		monitorOgg.uscita(TipoNave);


        }
    }

}
